<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * MaxSite CMS
 * плагин comuser_uploader
**/

// выдача списка файлов в кабинет комюзера с выбранной сортировкой

if ( $post = mso_check_post(array('comusers_id' , 'sort')) )
{
	mso_checkreferer(); // защищаем реферер

	$comusers_id = $post['comusers_id'];
    if (!is_numeric($comusers_id)) die('comuser_error');
		
	$options = mso_get_option('comuser_uploader', 'plugins', array() );

    // проверим залогиненность 
    if ( !($comuser = is_login_comuser()) ) die('no login');
    if ($comuser['comusers_id'] != $comusers_id) die('comuser_error');

	if (!isset($post['sort'])) $post['sort'] = 1;
	if (!isset($options['user_subdir'])) $options['user_subdir'] = 'userfile';
	
    // подключим функции получения загрузок пользователя со ссылками на место использования	
    require (getinfo('plugins_dir') . 'comuser_uploader/functions_userfile.php' );	   
	$dirs = get_userfiles($comusers_id, $options['user_subdir'], $post['sort']);
		   
	$all_files_res = '';

	$allowed_types = (isset($options['allowed_types_comuser'])) ? $options['allowed_types_comuser'] : 'gif|jpg|jpeg|png|pdf';
	$allowed_ext = explode('|', $allowed_types);
	
	$show_size = (isset($options['show_size'])) ? $options['show_size'] : '1';

    $subdir = (isset($options['user_subdir'])) ? $options['user_subdir'] : 'userfile';
    $current_dir = $subdir . '/' . $comusers_id;

	$uploads_dir = getinfo('uploads_dir') . $current_dir;
	$uploads_url = getinfo('uploads_url') .  $current_dir;
	
	
	foreach ($dirs as $file)
	{
		$ext = strtolower(str_replace('.', '', strrchr($file['file'], '.'))); // расширение файла
		if (!in_array($ext, $allowed_ext)) continue;
		$this_img = ($ext == 'jpg' or $ext == 'jpeg' or $ext == 'gif' or $ext == 'png');
		
		$title = htmlspecialchars($file['file']);
		
		$u_file = $mini = $mini_100 = $uploads_url. '/' . $file['file'];
		
		// адрес относительно сайта
		$u_file_site = str_replace(getinfo('site_url'), '', $u_file);
		
		if ($this_img) 
		{
			if (file_exists($uploads_dir . '/_mso_i/' . $file['file']))
				$mini_100 = $mini = $uploads_url . '/_mso_i/' . $file['file'];
			
			if (file_exists($uploads_dir . '/mini/' . $file['file']))
				$mini = $uploads_url . '/mini/' . $file['file'];
		}
		
		$all_files_res .= '<div class="all-files-image">';
		$all_files_res .= '<div class="all-files-image-mini">';			
		if ($this_img) // изображение 
		{
            $all_files_res .= 
			   '<a class="lightbox" target="_blank" title="' . $title  . ' ' .$file['date'] . '" href="' . $u_file . '"><img class="w100px-max" src="' . $mini_100 . '"></a>';
		}
		else  // файл 
		{
			$all_files_res .= '<a target="_blank" href="' . $u_file . '"><img src="' . getinfo('admin_url') . 'plugins/admin_files/document_plain.png" title="' . $title . ' ' . $file['date'] . '"></a>';
		}
		
        $use_out = '';
		if ($file['use']) 
        {
			//$use_out .= t('Использовано: ');
		    foreach ($file['use'] as $use)
            {
                $link = getinfo('siteurl') . $use['link'];
                $use_out .= '<a href="' . $link . '" target="_blank" title="Перейти к сообщению ' . $use['title'] . ', в котором использован файл">* </a>';
            }	
            $use_out = '<span title="' . t('Использовано') . '">' . $use_out . '</span>';			
        }
       
		$all_files_res .= 
			      '<div class="mar5-t">'
				. '<span title="' . t('Удалить файл') . '" onclick="del_file(\'' . $file['file'] . '\')">' . t('Удалить') . '</span>'
				. $use_out 
				. '</div></div>';
	    // $all_files_res .= '<div class="all-files-image-actions"></div>';		

		$all_files_res .= '</div>'; 
	}
	
	if (!$all_files_res) $all_files_res = $comusers_id . t('Нет загруженных файлов');
	echo $all_files_res . '<div class="clearfix"></div>';
}


elseif ( $post = mso_check_post(array('comusers_id', 'deletefile')) )
{
	mso_checkreferer(); // защищаем реферер
  
   if (!is_numeric($post['comusers_id'])) die('comuser_error');
	
   // проверим залогиненность 
   if (! ($comuser = is_login_comuser()) ) die('no login');
   if ($comuser['comusers_id'] != $post['comusers_id']) die('comuser_error');	
	
	$current_dir = $post['comusers_id'];	

	$deletefile = $post['deletefile'];

	$options = mso_get_option('manager_comuser', 'plugins', array() );	
    
	$subdir = (isset($options['user_subdir'])) ? $options['user_subdir'] : 'userfile';
	$deldir = (isset($options['user_deldir'])) ? $options['user_deldir'] : 'deleted';

    $current_dir = $subdir . '/' . $post['comusers_id'];

	$uploads_dir = getinfo('uploads_dir') . $current_dir . '/';
	
	$deleted_dir = getinfo('uploads_dir') . $deldir . '/' . $post['comusers_id'];
	
	// mso_flush_cache_mask('get_userfiles');
	 mso_flush_cache();
	
	$file = $uploads_dir . $deletefile;
	$mini = $uploads_dir . 'mini/' . $deletefile;
	$mini_100 = $uploads_dir . '_mso_i/' . $deletefile;
	
	$file2 = $deleted_dir . '/' . $deletefile;
	$mini2 = $deleted_dir . '/mini/' . $deletefile;
	$mini_1002 = $deleted_dir . '/_mso_i/' . $deletefile;

    
	if (!is_dir(getinfo('uploads_dir') . $deldir) ) // нет каталога
    {
		// нет каталога, пробуем создать
		@mkdir(getinfo('uploads_dir') . $deldir, 0777);
    }
		
	if (!is_dir($deleted_dir) ) // нет каталога
    {
		// нет каталога, пробуем создать
		@mkdir($deleted_dir, 0777); 
		@mkdir($deleted_dir . '/_mso_i', 0777); 
		@mkdir($deleted_dir . '/mini', 0777);
    }
	
	if (file_exists($file))
	{
        $log = date("m.d.y H:i:s", time()) . ' DEL  comuser_id: ' . $post['comusers_id'] . '   ' . $deletefile . '<br>';
	    file_put_contents(getinfo('plugins_dir') .'comuser_uploader/log.txt' , $log, FILE_APPEND);		
		
		// mso_flush_cache_mask('get_userfiles');
	    mso_flush_cache();
		
		copy ($file , $file2);
		@unlink($file);
		if (file_exists($mini)) {copy ($mini , $mini2); @unlink($mini);}
		if (file_exists($mini_100)) {copy ($mini_100 , $mini_1002); @unlink($mini_100);}
	}
		
	
}

else die('unknow');
# end of file