<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * MaxSite CMS
 * плагин comuser_uploader
**/

// получение файлов пользователя
// может вызываться из формы коммнтария или личного кабинета
// вызывается из manager-comments.php
// type = 0 или отсутствует - вызов из комментироания;  type = 1 - личный кабинет

if ( $post = mso_check_post(array('comusers_id')) )
{
	mso_checkreferer(); // защищаем реферер

	$comusers_id = $post['comusers_id'];
	
    if (!is_numeric($comusers_id)) die('comuser_error');
		
	$options = mso_get_option('comuser_uploader', 'plugins', array() );

    // проверим залогиненность если указно не отдавать чужие загрузки
	if (isset($options['no_public_uploads']) and $options['no_public_uploads']) 
	{	
      if ( !($comuser = is_login_comuser()) ) die('no login');
      if ($comuser['comusers_id'] != $comusers_id) die('comuser_error');
    }
	
	$all_files_res = '';

	$allowed_types = (isset($options['allowed_types_comuser'])) ? $options['allowed_types_comuser'] : 'gif|jpg|jpeg|png|pdf';
	$allowed_ext = explode('|', $allowed_types);
	
	$frame_types_comuser = (isset($options['frame_types_comuser'])) ? $options['frame_types_comuser'] : '|pdf';
	$frame_ext = explode('|', $frame_types_comuser);
	
	$show_size = (isset($options['show_size'])) ? $options['show_size'] : '1';

    $subdir = (isset($options['user_subdir'])) ? $options['user_subdir'] : 'userfile';
    $current_dir = $subdir . '/' . $comusers_id;

	$uploads_dir = getinfo('uploads_dir') . '/' . $current_dir;
	$uploads_url = getinfo('uploads_url') .  $current_dir;
	
	$CI = & get_instance();
	$CI->load->helper('directory');
	$CI->load->helper('file');
	
	// все файлы в массиве $dirs
	$dirs = directory_map($uploads_dir, 2); // только в текущем каталоге
	
	if (!$dirs) $dirs = array();

	// отсортировать файлы в обратно порядке по времени загрузки — новые в начало списка
	$dirs0 = array();
	foreach ($dirs as $file)
	{
		if (is_array($file)) continue; // это каталог, пропускаем
		
		// ключ = время.файл чтобы учесть одно и тоже время разных файлов 
		$dirs0[filemtime($uploads_dir . '/' . $file) . $file] = $file;
	}
	
	krsort($dirs0);
	$dirs = $dirs0;
	
	foreach ($dirs as $file)
	{
		if (is_array($file)) continue; // каталог — это массив — нам здесь не нужен
		
		$title = '';
		
		$ext = strtolower(str_replace('.', '', strrchr($file, '.'))); // расширение файла
		
		if (!in_array($ext, $allowed_ext)) continue;
		
		$this_img = ($ext == 'jpg' or $ext == 'jpeg' or $ext == 'gif' or $ext == 'png');
		
		$time_file = date(" | Y-m-d H:i:s", filemtime($uploads_dir . '/' . $file));
		
		$title = htmlspecialchars($file);
		
		$u_file = $mini = $mini_100 = $uploads_url. '/' . $file;
		
		// адрес относительно сайта
		$u_file_site = str_replace(getinfo('site_url'), '', $u_file);
		
		if ($this_img) 
		{
			if (file_exists($uploads_dir . '/_mso_i/' . $file))
				$mini_100 = $mini = $uploads_url . '/_mso_i/' . $file;
			
			if (file_exists($uploads_dir . '/mini/' . $file))
				$mini = $uploads_url . '/mini/' . $file;
		}
		
		$all_files_res .= '<div class="all-files-image">';
					
		// . '<div class="all-files-image-mini">'
		if (!isset($post['type']) or !$post['type']) // вызов из комментирования
		{
		    if ($this_img) 	 
			{	
                
				if (!isset($options['add_cod_img']) or !$options['add_cod_img']) $add_cod = '[myimg=' . $comusers_id . ']' . $file . '[/myimg]'; // bb-код
				elseif ($options['add_cod_img'] == 1) $add_cod = '<a class="lightbox" title="' . $title . '" href="' . $u_file . '"><img src="' . $mini . '"></a>'; // вставить миниатюру
			    else $add_cod = '<img title="' . $title  . $time_file . '" src="' .$u_file . '>'; // вставить изображение
				
				
				// добавляем 
		        $all_files_res .=  
		            '<img title="' . t('Вставить в текст') . '" class="w100px-max" src="' . $mini_100 . '" onclick="addSmile(\'' . stripslashes(htmlspecialchars($add_cod)) . '\', \'comments_content\');">';
			}
			else 
			{
                if (!isset($options['add_cod_file']) or !$options['add_cod_file']) 
				{
					if (in_array($ext, $frame_ext))
					  $add_cod = stripslashes(htmlspecialchars('[mydoc='.$comusers_id.']' . $file . '[/mydoc]')); // вставить bb-код 
			        else
					  $add_cod = stripslashes(htmlspecialchars('[myfile='.$comusers_id.']' . $file . '[/myfile]')); // вставить bb-код 
				}
				else $add_cod = '<a title="' . $title  . $time_file . '"target="_blank" href="' . $u_file . '">'; // вставить ссылку
		       
			   $all_files_res .= 
		            '<img title="' . $title  . $time_file . '" class="w100px-max" src="' . getinfo('admin_url') . 'plugins/admin_files/document_plain.png" onclick="addSmile(\'' . stripslashes(htmlspecialchars($add_cod)) . '\', \'comments_content\');">';
			}
        }	
		else // у нас личный кабинет - код вставки не формируется при вызове не из комментария, но есть кнопки действий
		{
		    if ($this_img) // изображение 
		    {
                $all_files_res .= 
			      '<a class="lightbox" target="_blank" title="' . $title  . $time_file . '" href="' . $u_file . '"><img class="w100px-max" src="' . $mini_100 . '"></a>';

		    }
		    else  // файл 
		    {
			    $all_files_res .= '<a target="_blank" href="' . $u_file . '"><img src="' . getinfo('admin_url') . 'plugins/admin_files/document_plain.png" title="' . $title . $time_file . '"></a>';
		    }
		
		    $all_files_res .= 
			      '<div class="mar5-t">'
				. '<span title="' . t('Получить URL-адрес файла') .' - ' . $u_file . '" onclick="jAlert(\'<textarea cols=70 rows=3>' . $u_file . '</textarea>\', \'' . t('Адрес файла') . '\'); return false;">URL</span></div></div>' 
				. '<span title="' . t('Удалить файл') . '" onclick="del_file(\'' . $file .'\')">' . t('Удалить') . '</span>'
				. '</div>';
			$all_files_res .= '<div class="all-files-image-actions"></div>';		
		}

		$all_files_res .= '</div>'; 
	}
	
	if (!$all_files_res) $all_files_res = t('Нет загруженных файлов');
	echo $all_files_res . '<div class="clearfix"></div>';
}


elseif ( $post = mso_check_post(array('comusers_id', 'deletefile')) )
{
	mso_checkreferer(); // защищаем реферер
  
  if (!is_numeric($comusers_id)) die('comuser_error');
	
   // проверим залогиненность 
   if ($comuser = is_login_comuser()) die('no login');
   if ($comuser['comusers_id'] != $post['comusers_id']) die('comuser_error');	
	
	$current_dir = $post['comusers_id'];	

	$deletefile = $post['deletefile'];

	$options = mso_get_option('manager_comuser', 'plugins', array() );	
    
	$subdir = (isset($options['user_subdir'])) ? $options['user_subdir'] : 'userfile/';
    $current_dir = $subdir . $comusers_id;

	$uploads_dir = getinfo('uploads_dir') . $current_dir . '/';
	
	$file = $uploads_dir . $deletefile;
	$mini = $uploads_dir . 'mini/' . $deletefile;
	$mini_100 = $uploads_dir . '_mso_i/' . $deletefile;
	
	if (file_exists($file))
	{
		@unlink($file);
		if (file_exists($mini)) @unlink($mini);
		if (file_exists($mini_100)) @unlink($mini_100);
	}
}

else die('unknow');
# end of file