<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

/**
 * MaxSite CMS
 * Плагин profile
 */ 

function profile_autoload()
{
	mso_create_allow('profile_edit', t('Админ-доступ к редактированию profile', __FILE__));
	mso_hook_add( 'admin_init', 'profile_admin_init');
	//mso_profile_widget('profile_widget', t('profile', __FILE__)); //
	mso_hook_add('custom_page_404', 'profile_custom_page_404');
	mso_hook_add('init', 'profile_init');
	$options = mso_get_option('profile', 'plugins', array());
	$widget_fcomments_priority = (isset($options['widget_fcomments_priority'])) ? $options['widget_fcomments_priority'] : 10; 
	$widget_flogin_priority = (isset($options['widget_flogin_priority'])) ? $options['widget_flogin_priority'] : 10; 	
	mso_hook_add('page-comment-form', 'profile_page_comment_form', $widget_fcomments_priority); # хук на форму комментов
	mso_hook_add('login_form_auth', 'profile_login_form_auth', $widget_flogin_priority); # хук на форму логина	
	mso_hook_add( 'head', 'profile_auth_head');
    mso_register_widget('profile_widget', t('Форма Auth')	);
	mso_hook_add( 'main_menu_add_comuser', 'profile_menu'); // добавление в меню ссылок на приватные страницы 
}

// добавляем пункт в меню пользователя
function profile_menu($menu='') 
{
  $profile_usermenu = mso_get_option('profile_usermenu', 'plugins', '');
  
  return $menu . NR . $profile_usermenu;
}

function profile_auth_head($args = array())
{
	 if (!is_login_comuser())
		echo '<script src="http://ulogin.ru/js/ulogin.js"></script>';
	return $args;
}


function profile_head($arg = array())
{
	echo '<link rel="stylesheet" type="text/css" href="' . getinfo('plugins_url') . 'profile/style.css">';
}

function profile_activate($args = array())
{
	mso_create_allow('profile_edit',  t('Админ-доступ к настройкам', 'admin'));
	require(getinfo('plugins_dir') . 'profile/install.php');
	profile_add_options();
	return $args;
}


function profile_uninstall($args = array())
{
	mso_delete_option_mask('profile', 'plugins'); // удалим созданные опции
	mso_remove_allow('profile_edit'); // удалим созданные разрешения
	mso_delete_option_mask('profile_widget', 'plugins' );	
	mso_delete_option_mask('profile_auth', 'plugins' );	
	return $args;
}



function profile_admin_init($args = array())
{
	if ( mso_check_allow('profile_edit') )
	{
		mso_admin_menu_add('plugins', 'profile', t('Личный кабинет', __FILE__));
		mso_admin_url_hook ('profile', 'profile_admin_page');
	}
	return $args;
}



function profile_admin_page($args = array())
{
	# выносим админские функции отдельно в файл
	if ( !mso_check_allow('profile_edit') )
	{
		echo t('Доступ запрещен', 'plugins');
		return $args;
	}
	# выносим админские функции отдельно в файл
	mso_hook_add_dinamic( 'mso_admin_header', ' return $args . "' . t('profile', __FILE__) . '"; ' );
	mso_hook_add_dinamic( 'admin_title', ' return "' . t('profile', __FILE__) . ' - " . $args; ' );
	require(getinfo('plugins_dir') . 'profile/admin/index.php');
}


function profile_custom_page_404($args = false)
{
  // вывод приватной страницы профиля пользователя (личного кабинета)

  $options = mso_get_option('profile', 'plugins', array());
  $segment1 = mso_segment(1);
  $segment2 = mso_segment(2);
  $segment3 = mso_segment(3);
  $site_url = getinfo('siteurl');
  
  $subdir = 'userfile'; // подкаталог для загрузок комюзерами

  $options['profile_slug'] = isset($options['profile_slug']) ? $options['profile_slug'] : 'profile';
  $options['profile_user_slug'] = isset($options['profile_user_slug']) ? $options['profile_user_slug'] : 'profile-user';
  $options['profiles_slug'] = isset($options['profiles_slug']) ? $options['profiles_slug'] : 'profiles';
  $options['profiles_user_slug'] = isset($options['profiles_user_slug']) ? $options['profiles_user_slug'] : 'profiles-users';
    	
  $options['register_slug'] = isset($options['register_slug']) ? $options['register_slug'] : 'registration';

  $options['reverse_breadcrumbs'] = isset($options['reverse_breadcrumbs']) ? $options['reverse_breadcrumbs'] : 1;

  if (!isset($options['profile_plugins'])) $options['profile_plugins'] = array('profile, dialog, comuser_uploader'); // плагины, подключающие свои элементы

  $error = '';
  // регистрация (свой файл или файл maxsite шаблона default)
  if ( (mso_segment(1) == $options['register_slug']) and ($options['register_slug'] != 'registration'))
  {
	require( getinfo('plugins_dir') . 'profile/register.php' ); // подключили страницу регистрации
	return true; // выходим с true
  }  
	
  // публичные страницы пользователя (профиль пользователя)
  if ( (mso_segment(1) == $options['profiles_slug']) or (mso_segment(1) == $options['profiles_user_slug'])) // если сегмент профиля
  {
    require( getinfo('plugins_dir') . 'profile/pub_pages/index.php' );
    if (!$error)  return true;
  }    
	 
  // приватные страницы пользователя (личный кабинет)
  if ( (mso_segment(1) == $options['profile_slug']) or (mso_segment(1) == $options['profile_user_slug'])) 
  {
	require( getinfo('plugins_dir') . 'profile/priv_pages/index.php' ); 
    if (!$error)  return true;
  }    

	return $args;
}

# авторизация ulogin в форме логина
function profile_login_form_auth($text = '') 
{
    $options_auth = mso_get_option('profile_auth', 'plugins', array() ); // получаем опции

	if (isset($options_auth['widget_type_flogin']) and $options_auth['widget_type_flogin']) $widget_type = $options_auth['widget_type_flogin']; 
	else $widget_type = 'small';

	if (isset($options_auth['auth_title_flogin'])) $title = $options_auth['auth_title_flogin']; 
	else $title = 'ulogin';

	require (getinfo('plugins_dir') . 'profile/auth_providers/ulogin/ulogin.php');
	$text .= $title . $out1 . '[end]' ;

	return $text;
}

# авторизация ulogin в форме комментариев
function profile_page_comment_form($args = array()) 
{
    $options_auth = mso_get_option('profile_auth', 'plugins', array() ); // получаем опции
	
	if (isset($options_auth['widget_type']) and $options_auth['widget_type']) $widget_type = $options_auth['widget_type']; 
	else $widget_type = 'small';
    
	if (isset($options_auth['auth_title'])) $title = $options_auth['auth_title']; 
	else $title = 'Вход через';
	
	require (getinfo('plugins_dir') . 'profile/auth_providers/ulogin/ulogin.php');
    echo $title . $out1;
	return $args;
}



# тут происходит авторизация ulogin 
function profile_init($arg = array())
{
	if (mso_segment(1) == 'maxsite-ulogin-auth') 
    require (getinfo('plugins_dir') . 'profile/auth_providers/ulogin/auth.php');
	return $arg;
}


// виджеты в отдельном файле
require (getinfo('plugins_dir') . 'profile/widgets.php');
