<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

/**
 * MaxSite CMS
 * Плагин profile
 */ 

// отдельный файл с виджетами

// виджет авторизации
function profile_widget($num = 1) 
{
	$out = '';
	
	$widget = 'profile_widget_' . $num; // имя для опций = виджет + номер
	$options = mso_get_option($widget, 'plugins', array() ); // получаем опции
  		

	if ($comuser = is_login_comuser())
	{
        if (!isset($options['profile_slug'])) $options['profile_slug'] = 'profile'; 
        $options['ulogin_slug'] = 'logininfo'; 
        if (!isset($options['default_nik'])) $options['default_nik'] = 'Привет'; 
        if (!isset($options['title'])) $options['title'] = 'Личный кабинет'; 
	
        if (!isset($options['format_title_prov'])) $options['format_title_prov'] = '<p><strong>#NIK#</strong> #PROV#</p>'; 
        if (!isset($options['format_title'])) $options['format_title'] = '<p><strong>#NIK#</strong></p>'; 
    
	    if (!$comuser['comusers_nik']) $nik = $options['default_nik'];
	    else $nik = $comuser['comusers_nik'];
					
	    // если вход через провайдера
	    if (isset($comuser['provider_key']))
	    {
		  $prov = '<a href="' . $comuser['provider_user_url'] . 
    '" title="' . $comuser['provider_user_url'] . '"><img src="'.getinfo('plugins_url').'profile/img/'.$comuser['provider_key'].'.png"></a>';
          $out .= str_replace(array('#NIK#' , '#PROV#'), 
							array($nik, $prov), $options['format_title_prov']);
	    }
		else // вход логином и паролем
        $out .= str_replace('#NIK#',$nik, $options['format_title']);

		$out .= '<p>
				[<a href="' . getinfo('siteurl') . $options['profile_slug'] . '/' . $options['ulogin_slug'] . '">' . $options['title'] . '</a>]
				[<a href="' . getinfo('siteurl') . 'logout'.'">' . t('выйти', 'plugins') . '</a>]</p>';				
	}
	else
	{
        $after_form = (isset($options['after_form'])) ? $options['after_form'] : '';
        if (!isset($options['login_email'])) $options['login_email'] = 'Email'; 
        if (!isset($options['login_password'])) $options['login_password'] = 'Пароль'; 
        if (!isset($options['login_form_auth_title'])) $options['login_form_auth_title'] = 'Вход через'; 
	   
	   if (!isset($options['registration']) or $options['registration'])
	    {
		    $registration = '<span class="registration"><a href="' . getinfo('siteurl') . 'registration">' . tf('Регистрация') . '</a></span>';
	    
		}
	    else $registration = '';		
		
		$out .= mso_login_form(array(
		    'login'=>$options['login_email'] . ' ',
			'password'=>$options['login_password'] . ' ',
			'submit'=>'',
			'form_end'=>$after_form,
			'submit_end' => $registration,
			'login_form_auth_title' => $options['login_form_auth_title']
			),
			getinfo('siteurl') . mso_current_url(), false);
	}
		
		
	// заменим заголовок, чтобы был в  h2 class="box"
	if ( isset($options['header']) and $options['header'] ) 
		$options['header'] = mso_get_val('widget_header_start', '<div class="mso-widget-header"><span>') . $options['header'] . mso_get_val('widget_header_end', '</span></div>');
	else $options['header'] = '';
		
	if ($options['header']) $out = $options['header'] . $out;
	
	return $out;
}


# форма настройки виджета 
# имя функции = виджет_form
function profile_widget_form($num = 1) 
{
	$widget = 'profile_widget_' . $num; // имя для формы и опций = виджет + номер
	
	// получаем опции 
	$options = mso_get_option($widget, 'plugins', array());
	
	if ( !isset($options['header']) ) $options['header'] = '';
	if ( !isset($options['after_form']) ) $options['after_form'] = '';
    if (!isset($options['default_nik'])) $options['default_nik'] = 'Привет'; 
    if (!isset($options['format_title_prov'])) $options['format_title_prov'] = '<p><strong>#NIK#</strong> #PROV#</p>'; 
    if (!isset($options['format_title'])) $options['format_title'] = '<p><strong>#NIK#</strong></p>'; 	
    if (!isset($options['login_email'])) $options['login_email'] = 'Email'; 
    if (!isset($options['login_password'])) $options['login_password'] = 'Пароль'; 	
    if (!isset($options['registration'])) $options['registration'] = '1'; 	
    if (!isset($options['login_form_auth_title'])) $options['login_form_auth_title'] = 'Вход через'; 	
	
	// вывод самой формы
	$CI = & get_instance();
	$CI->load->helper('form');
	
	$form = '<p><div class="t150">' . t('Заголовок', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'header', 'value'=>$options['header'] ) ) ;
	
	$form .= '<p><div class="t150">' . t('Текст после формы входа:', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'after_form', 'value'=>$options['after_form'] ) ) ;
	$form .= '<p><div class="t150">&nbsp;</div> '. t('Например, ссылка на регистрацию', 'plugins') ;

	$form .= '<p><div class="t150">' . t('Вход с провайдером:', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'format_title_prov', 'value'=>$options['format_title_prov'] ) ) ;
	$form .= '<p><div class="t150">&nbsp;</div>  (#NIK# #PROV#)';

	$form .= '<p><div class="t150">' . t('Вход email+пароль:', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'format_title', 'value'=>$options['format_title'] ) ) ;
	$form .= '<p><div class="t150">&nbsp;</div>  (#NIK#)';

	$form .= '<p><div class="t150">' . t('Имя, если нет:', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'default_nik', 'value'=>$options['default_nik'] ) ) ;

	$form .= '<p><div class="t150">' . t('Поле email:', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'login_email', 'value'=>$options['login_email'] ) ) ;
	
	$form .= '<p><div class="t150">' . t('Поле password:', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'login_password', 'value'=>$options['login_password'] ) ) ;		

	$form .= '<p><div class="t150">' . t('Вход через:', 'plugins') . '</div> '. form_input( array( 'name'=>$widget . 'login_form_auth_title', 'value'=>$options['login_form_auth_title'] ) ) ;		


	$form .= '<p><div class="t150">' . t('Регистрация:', 'plugins') . '</div> '. form_dropdown( $widget . 'registration', array('0' => tf('Не показывать ссылку'), '1' => tf('Показывать ссылку'),), $options['registration']);		
	
	
	return $form;
}


# сюда приходят POST из формы настройки виджета
# имя функции = виджет_update
function profile_widget_update($num = 1) 
{
	$widget = 'profile_widget_' . $num; // имя для опций = виджет + номер
	
	// получаем опции
	$options = $newoptions = mso_get_option($widget, 'plugins', array());
	
	# обрабатываем POST
	$newoptions['header'] = mso_widget_get_post($widget . 'header');
	$newoptions['after_form'] = mso_widget_get_post($widget . 'after_form');
	$newoptions['format_title_prov'] = mso_widget_get_post($widget . 'format_title_prov');
	$newoptions['format_title'] = mso_widget_get_post($widget . 'format_title');
	$newoptions['default_nik'] = mso_widget_get_post($widget . 'default_nik');
	$newoptions['login_password'] = mso_widget_get_post($widget . 'login_password');
	$newoptions['login_email'] = mso_widget_get_post($widget . 'login_email');

	
	if ( $options != $newoptions ) 
		 mso_add_option($widget, $newoptions, 'plugins');
}

